//Unleashed Physics and Camera by DarknessStylus
//Originally named "Centered Camera"
//Based on my first script
//Now with counters xD

freeslot("S_PLAY_ALLDRIFT", "S_PLAY_DRIFTJUMP", "S_PLAY_DRIFTSTART", "S_PLAY_DRIFTEND", "sfx_drft2")

states[S_PLAY_ALLDRIFT] = {SPR_PLAY, SPR2_SPIN|FF_ANIMATE, 4, nil, 4, 5, S_PLAY_WALK}
states[S_PLAY_DRIFTEND] = {SPR_PLAY, SPR2_RUN|FF_ANIMATE, 4, nil, 4, 5, S_PLAY_WALK}
states[S_PLAY_DRIFTSTART] = {SPR_PLAY, SPR2_SPIN|FF_ANIMATE, 4, nil, 4, 5, S_PLAY_SPINDASH}
states[S_PLAY_DRIFTJUMP] = {SPR_PLAY, SPR2_ROLL|FF_ANIMATE, 8, nil, 3, 2, S_PLAY_SPINDASH}

S_sfx[sfx_drft2] = {false, 64, SF_NOMULTIPLESOUND}

COM_AddCommand("unleashedphys", function(player, arg)
	if arg
		if arg == "1" or arg == "true" or arg == "on"
		 	if io and player == consoleplayer
				local file = io.openlocal("client/unlphys.dat", "w+")
				file:write(arg)
				file:close()
			end
			player.unleashedphysenabler = true
			CONS_Printf(player, "Unleashed physics and camera are On.")
		elseif arg == "0" or arg == "false" or arg == "off"
			if io and player == consoleplayer
				local file = io.openlocal("client/unlphys.dat", "w+")
				file:write(arg)
				file:close()
			end	
			player.unleashedphysenabler = false
			CONS_Printf(player, "Unleashed physics and camera are Off.")
		elseif player.unleashedphysenabler
			CONS_Printf(player, "unleashedphys [on or off] - Enables Unleashed physics and camera. Currently On.")
		else
			CONS_Printf(player, "unleashedphys [on or off] - Enables Unleashed physics and camera. Currently Off.")
		end
	elseif player.unleashedphysenabler
		CONS_Printf(player, "unleashedphys [on or off] - Enables Unleashed physics and camera. Currently On.")
	else
		CONS_Printf(player, "unleashedphys [on or off] - Enables Unleashed physics and camera. Currently Off.")
	end
end, 0)

COM_AddCommand("analogsens", function(player, arg)
	if arg
		if arg == "1" or arg == "true" or arg == "gens" or arg == "unwiished" or arg == "on"
		 	if io and player == consoleplayer
				local file = io.openlocal("client/analogsens.dat", "w+")
				file:write(arg)
				file:close()
			end
			player.analogsens = true
			CONS_Printf(player, "Analog sensitivity now is Gens/Wii Unleashed type.")
		elseif arg == "0" or arg == "false" or arg == "vanilla" or arg == "off"
			if io and player == consoleplayer
				local file = io.openlocal("client/analogsens.dat", "w+")
				file:write(arg)
				file:close()
			end	
			player.analogsens = false
			CONS_Printf(player, "Analog sensitivity now is Vanilla type.")
		elseif player.analogsens
			CONS_Printf(player, "analogsens [1 or 0] - Changes the sensitivity for your analog. Currently Gens/Wii Unleashed type.")
		else
			CONS_Printf(player, "analogsens [1 or 0] - Changes the sensitivity for your analog. Currently Vanilla type.")
		end
	elseif player.analogsens
		CONS_Printf(player, "analogsens [1 or 0] - Changes the sensitivity for your analog. Currently Gens/Wii Unleashed type.")
	else
		CONS_Printf(player, "analogsens [1 or 0] - Changes the sensitivity for your analog. Currently Vanilla type.")
	end
end, 0)

COM_AddCommand("driftmode", function(player, arg)
	if arg
		if arg == "1" or arg == "true" or arg == "unleashed" or arg == "unwiished" or arg == "on"
			if io and player == consoleplayer
				local file = io.openlocal("client/driftmode.dat", "w+")
				file:write(arg)
				file:close()
			end
			player.driftmodealt = false
			player.driftmode = true
			CONS_Printf(player, "Drift mode now is Unleashed type.")
		elseif arg == "0" or arg == "false" or arg == "off"
			if io and player == consoleplayer
				local file = io.openlocal("client/driftmode.dat", "w+")
				file:write(arg)
				file:close()
			end
			player.driftmodealt = false
			player.driftmodealt2 = false
			player.driftmode = false
			CONS_Printf(player, "Drift mode now is Old type.")
		elseif arg == "2" or arg == "alt" or arg == "fixed" or arg == "gens"
			if io and player == consoleplayer
				local file = io.openlocal("client/driftmode.dat", "w+")
				file:write(arg)
				file:close()
			end
			player.driftmodealt = true
			player.driftmodealt2 = false
			player.driftmode = false
			CONS_Printf(player, "Drift mode now is Generations type.")
		elseif arg == "3" or arg == "alt2" or arg == "gensnojump"
			if io and player == consoleplayer
				local file = io.openlocal("client/driftmode.dat", "w+")
				file:write(arg)
				file:close()
			end
			player.driftmodealt = false
			player.driftmodealt2 = true
			player.driftmode = false
			CONS_Printf(player, "Drift mode now is Custom type.")
		elseif player.driftmode
			CONS_Printf(player, "driftmode - Changes the drift type. Currently Unleashed type.")
		elseif player.driftmodealt
			CONS_Printf(player, "driftmode - Changes the drift type. Currently Generations type.")
		elseif player.driftmodealt2
			CONS_Printf(player, "driftmode - Changes the drift type. Currently Custom type.")
		else
			CONS_Printf(player, "driftmode - Changes the drift type. Currently Old type.")
		end
	elseif player.driftmode
		CONS_Printf(player, "driftmode - Changes the drift type. Currently Unleashed type.")
	elseif player.driftmodealt
		CONS_Printf(player, "driftmode - Changes the drift type. Currently Generations type.")
	elseif player.driftmodealt2
		CONS_Printf(player, "driftmode - Changes the drift type. Currently Custom type.")
	else
		CONS_Printf(player, "driftmode - Changes the drift type. Currently Old type.")
	end
end, 0)

COM_AddCommand("airchanges", function(player, arg)
	if arg
		if arg == "1" or arg == "true" or arg == "on"
		 	if io and player == consoleplayer
				local file = io.openlocal("client/airchanges.dat", "w+")
				file:write(arg)
				file:close()
			end
			player.airchanges = true
			CONS_Printf(player, "Air changes are on.")
		elseif arg == "0" or arg == "false" or arg == "off"
			if io and player == consoleplayer
				local file = io.openlocal("client/airchanges.dat", "w+")
				file:write(arg)
				file:close()
			end	
			player.airchanges = false
			CONS_Printf(player, "Air changes are off.")
		elseif player.airchanges
			CONS_Printf(player, "airchanges [On or Off] - Add higher gravity and drag. Currently On.")
		else
			CONS_Printf(player, "airchanges [On or Off] - Add higher gravity and drag. Currently Off.")
		end
	elseif player.airchanges
		CONS_Printf(player, "airchanges [On or Off] - Add higher gravity and drag. Currently On.")
	else
		CONS_Printf(player, "airchanges [On or Off] - Add higher gravity and drag. Currently Off.")
	end
end, 0)

COM_AddCommand("camerachanges", function(player, arg)
	if arg
		if arg == "1" or arg == "true" or arg == "on"
			if io and player == consoleplayer
				local file = io.openlocal("client/vcamera.dat", "w+")
				file:write(arg)
				file:close()
			end
			player.vcameramodealt = false
			player.vcameramodealt2 = false
			player.vcameramode = true
			CONS_Printf(player, "Camera now has vertical camera.")
		elseif arg == "0" or arg == "false" or arg == "off"
			if io and player == consoleplayer
				local file = io.openlocal("client/vcamera.dat", "w+")
				file:write(arg)
				file:close()
			end
			player.vcameramodealt = false
			player.vcameramodealt2 = false
			player.vcameramode = false
			CONS_Printf(player, "Camera now is Old type.")
		elseif arg == "2" or arg == "alt" or arg == "unleashed"
			if io and player == consoleplayer
				local file = io.openlocal("client/vcamera.dat", "w+")
				file:write(arg)
				file:close()
			end
			player.vcameramodealt = true
			player.vcameramodealt2 = false
			player.vcameramode = false
			CONS_Printf(player, "Camera now has FOV changes and vertical camera.")
		elseif arg == "3" or arg == "alt2" or arg == "fovonly"
			if io and player == consoleplayer
				local file = io.openlocal("client/vcamera.dat", "w+")
				file:write(arg)
				file:close()
			end
			player.vcameramodealt = false
			player.vcameramodealt2 = true
			player.vcameramode = false
			CONS_Printf(player, "Camera now has FOV changes only.")
		elseif player.vcameramode
			CONS_Printf(player, "camerachanges - Changes some things on the camera. Currently New vertical camera.")
		elseif player.vcameramodealt
			CONS_Printf(player, "camerachanges - Changes some things on the camera. Currently FOV changes and vertical camera.")
		elseif player.vcameramodealt2
			CONS_Printf(player, "camerachanges - Changes some things on the camera. Camera now has FOV changes only.")
		else
			CONS_Printf(player, "camerachanges - Changes some things on the camera. Currently Off.")
		end
	elseif player.vcameramode
		CONS_Printf(player, "camerachanges - Changes some things on the camera. Currently New vertical camera.")
	elseif player.vcameramodealt
		CONS_Printf(player, "camerachanges - Changes some things on the camera. Currently FOV changes and vertical camera.")
	elseif player.vcameramodealt2
		CONS_Printf(player, "camerachanges - Changes some things on the camera. Camera now has FOV changes only.")
	else
		CONS_Printf(player, "camerachanges - Changes some things on the camera. Currently Off.")
	end
end, 0)

COM_AddCommand("unlphysdebug", function(player, arg)
	if arg
		if arg == "1" or arg == "true" or arg == "on"
		 	/*if io and player == consoleplayer
				local file = io.openlocal("client/unlphysdebug.dat", "w+")
				file:write(arg)
				file:close()
			end*/
			player.debugthings1 = true
			//CONS_Printf(player, "Debug is On")
		elseif arg == "0" or arg == "false" or arg == "off"
			/*if io and player == consoleplayer
				local file = io.openlocal("client/unlphysdebug.dat", "w+")
				file:write(arg)
				file:close()
			end*/
			player.debugthings1 = false
			//CONS_Printf(player, "Unleashed physics and camera are Off")
		end
		/*elseif player.unleashedphysenabler
			CONS_Printf(player, "unleashedphys [on or off] - Enables Unleashed physics and camera. Currently On.")
		else
			CONS_Printf(player, "unleashedphys [on or off] - Enables Unleashed physics and camera. Currently Off.")
		end
	elseif player.unleashedphysenabler
		CONS_Printf(player, "unleashedphys [on or off] - Enables Unleashed physics and camera. Currently On.")
	else
		CONS_Printf(player, "unleashedphys [on or off] - Enables Unleashed physics and camera. Currently Off.")*/
	end
end, 0)

//Momentum limter
local MomentumLimiter = function(mo,svr)

if (not (mo.skin == "adventuresonic"))
	svr = 77*mo.scale*1
else
	svr = 88*FRACUNIT
end

	/*if mo.eflags&MFE_UNDERWATER then
		svr = $/2
	end*/
	
	if mo.player.powers[pw_sneakers]
	or mo.player.powers[pw_super]
		svr = $*2
	end
	
	if mo.player.cmd.forwardmove < 0
	or mo.player.cmd.forwardmove == 0
	//or mo.player.cmd.sidemove ~= 0
	or mo.skin == "modernsonic" --silly failcheck
	or mo.player.isondriftvar == 1
	or mo.player.pflags & PF_SPINNING
	or (not (P_IsObjectOnGround(mo)))
		return
	end
	
	if mo.player.speed > svr then
		//mo.movefactor = 1*FRACUNIT/4
		//mo.friction = 30*FRACUNIT/32
		P_InstaThrust(mo, mo.angle, svr)
		//mo.player.normalspeed = $ - FRACUNIT
		return true
	else
		return false
	end
end

local UnleashedDrift = function(mo)

local player = mo.player

	if player.cmd.forwardmove < -25
	or player.isondriftvar == 0
	or (not (P_IsObjectOnGround(mo)))
	or not (player.mo.flags2 & MF2_TWOD)
		return
	end
		
	if player.isondriftvar == 1
	and P_PlayerInPain(player) == false
		if player.speed < 39*FRACUNIT
		and player.speed > 1*FRACUNIT
			//P_InstaThrust(player.mo, mo.angle, 38*FRACUNIT)
			P_Thrust(player.mo, mo.angle, 5*FRACUNIT)
			//mo.momx = $1*5/4
			//mo.momy = $1*5/4
			//mo.friction = 34*FRACUNIT/32
		end
		if player.speed < 46*FRACUNIT
		and player.speed > 39*FRACUNIT
			P_InstaThrust(player.mo, mo.angle, 41*FRACUNIT)
			//mo.friction = 32*FRACUNIT/32
		end
		if player.speed < 70*FRACUNIT
		and player.speed > 46*FRACUNIT
			//mo.momx = $1*5/6
			//mo.momy = $1*5/6
			if player.driftmodealt
			or player.driftmodealt2
				P_InstaThrust(player.mo, mo.angle, player.modspeed - 3*FRACUNIT)
			end
		end
		if player.speed > 70*FRACUNIT
			if player.driftmodealt
			or player.driftmodealt2
				P_InstaThrust(player.mo, mo.angle, (FixedMul(74*FRACUNIT, player.mo.scale)+5*FRACUNIT)+cos(player.aiming))
			else
				P_Thrust(player.mo, mo.angle, (FixedMul(3*FRACUNIT, player.mo.scale)+3*FRACUNIT)+cos(player.aiming))
			end
		end
		if player.speed > 119*mo.scale*1
			P_InstaThrust(player.mo, mo.angle, 119*mo.scale*1)
		end
	end
end

local SimpleDrift = function(mo)

local player = mo.player

	if player.cmd.forwardmove < 0
	or player.isondriftvar == 0
	or (not (P_IsObjectOnGround(mo)))
		return
	end
		
	if player.isondriftvar == 1
		if player.cmd.buttons & BT_SPIN
			if player.speed < 55*FRACUNIT
			and player.mo.skin ~= "adventuresonic"
				P_Thrust(player.mo, mo.angle, (FixedMul(5*FRACUNIT, player.mo.scale)+3*FRACUNIT)+cos(player.aiming))
			else
				P_InstaThrust(player.mo, mo.angle, (FixedMul(50*FRACUNIT, player.mo.scale)+5*FRACUNIT)+cos(player.aiming))
			end
		else
			if player.speed > 70*FRACUNIT
				P_InstaThrust(player.mo, mo.angle, (FixedMul(70*FRACUNIT, player.mo.scale)+5*FRACUNIT)+cos(player.aiming))
			else
				P_InstaThrust(player.mo, mo.angle, (FixedMul(42*FRACUNIT, player.mo.scale)+5*FRACUNIT)+cos(player.aiming))
			end
		end
		if player.mo.skin == "modernsonic"
			if player.boosting == true
				P_InstaThrust(player.mo, mo.angle, (FixedMul(70*FRACUNIT, player.mo.scale)+5*FRACUNIT)+cos(player.aiming))
			elseif player.boosting == false
				P_InstaThrust(player.mo, mo.angle, (FixedMul(42*FRACUNIT, player.mo.scale)+5*FRACUNIT)+cos(player.aiming))
			end
		end
	end
end

//Better wall checker finally jajajajaja YES!!!!
addHook("MobjMoveBlocked", function(mo)
	mo.player.wallcounterc = true
end, MT_PLAYER)

addHook("MobjLineCollide", function(mo, line)
	if not(mo.player) then return end
	if not mo and mo.valid then return end
	if P_IsObjectOnGround(mo) then return end
	if mo.player.wallcounterc == false then return end
	if mo.player.unleashedphysenabler == false then return end
		mo.angle = mo.player.drawangle
	end, MT_PLAYER)

addHook("PlayerCanDamage", function(player, enemy)
	if player.isondriftvar == 1
	or player.driftjumpvar > 0
	and P_PlayerInPain(player) == false
	return true
	end
end)

//Un-nil-ifier
addHook("PreThinkFrame", do
	for player in players.iterate
		if player.unleashedphysenabler == nil
			player.unleashedphysenabler = false
			end
		if player.debugthings1 == nil
			player.debugthings1 = false
			end
		if player.cancelboostvar == nil
			player.cancelboostvar = 0
			end
		if player.driftboostcountervar == nil
			player.driftboostcountvar = 0
			end
		if player.modspeed == nil
			player.modspeed = 0
			end
		if player.momspeedvar == nil
			player.momspeedvar = 0
			end
		if player.wallcounterc == nil
			player.wallcounterc = false
			end
		if player.normalcamc == nil
			player.normalcamc = false
			end
		if player.hspringcamc == nil
			player.hspringcamc = 0
			end
		if player.speedturnvar == nil
			player.speedturnvar = 0
			end
		if player.isonairvar == nil
			player.isonairvar = 0
			end
		if player.isonairupvar == nil
			player.isonairupvar = 0
			end
		if player.beforeboostprevspd == nil
			player.beforeboostprevspd = 0
			end
		if player.isondriftvar == nil
			player.isondriftvar = 0
			end
		if player.prevpspeed2 == nil
			player.prevpspeed2 = 0
			end
		if player.isdriftingvar == nil
			player.isdriftingvar = 0
			end
		if player.isdriftdustvar == nil
			player.isdriftdustvar = 0
			end
		if player.unldriftcounter == nil
			player.unldriftcounter = 0
			end
		if player.driftjumpvar == nil
			player.driftjumpvar = 0
			end
		if player.driftstomper == nil
			player.driftstomper = 0
			end
		if player.jumperfixer == nil
			player.jumperfixer = 0
			end
		if player.jumperfixer2 == nil
			player.jumperfixer2 = 0
			end
		if player.moveallfactor == nil
			player.moveallfactor = 4*FRACUNIT/9
			end
		if player.aerealboostvar == nil
			player.aerealboostvar = 0
			end
		if player.acceleratorvar == nil
			player.acceleratorvar = 0
			end
		if player.boostanglechangervar == nil
			player.boostanglechanglervar = 0
			end
		if player.analogsens == nil
			player.analogsens = false
			end
		if player.sprungcounter == nil
			player.sprungcounter = 0
			end
		if player.driftmode == nil
			player.driftmode = false
			end
		if player.angleholdervar == nil
			player.angleholdervar = 0
			end
		if player.angleholdercounter == nil
			player.angleholdercounter = 0
			end
		if player.driftmodealt == nil
			player.driftmodealt = false
			end
		if player.driftmodealt2 == nil
			player.driftmodealt2 = false
			end
		if player.airchanges == nil
			player.airchanges = false
			end
		if player.localfriction2 == nil
			player.localfriction2 = 32*FRACUNIT/32
			end
		if player.momentumkillercounter == nil
			player.momentumkillercounter = 0
			end
		if player.momentumkillercounter2 == nil
			player.momentumkillercounter2 = 0
			end
		if player.momentumkillervar == nil
			player.momentumkillervar = 0
			end
		if player.vcameramode == nil
			player.vcameramode = 0
			end
		if player.vcameramodealt == nil
			player.vcameramodealt = 0
			end
		if player.vcameramodealt2 == nil
			player.vcameramodealt2 = 0
			end
		if player.isrunningvar == nil
			player.isrunningvar = 0
			end
		if player.isrunningvar2 == nil
			player.isrunningvar2 = 0
			end
		if player.fovchanger == nil
			player.fovchanger = 0
			end
		if player.fovchanger2 == nil
			player.fovchanger2 = 0
			end
		if player.prevcamerascale2 == nil
			player.prevcamerascale2 = 0
			end
		if player.driftcooldown == nil
			player.driftcooldown = 0
			end
		if player.driftlagvar == nil
			player.driftlagvar = 0
			end
		if player.driftlagactivator == nil
			player.driftlagactivator = 0
			end
		if player.camzchanger == nil
			player.camzchanger = 0
			end
		if player.isonjumpv == nil
			player.isonjumpv = 0
			end
		if player.isonjumpv2 == nil
			player.isonjumpv2 = 0
			end
		if player.cameraangstore == nil
			player.cameraangstore = 0
			end
		if player.camzholder == nil
			player.camzholder = 0
			end
		if player.jumpheldcv == nil
			player.jumpheldcv = 0
			end
		if player.jumpheldcv2 == nil
			player.jumpheldcv2 = 0
			end
		if player.wasdrifting == nil
			player.wasdrifting = 0
			end
		if player.groundmomzh == nil
			player.groundmomzh = 0
			end
		if player.groundfrictionchecker == nil
			player.groundfrictionchecker = 0
			end
		if player.campdistchecker == nil
			player.campdistchecker = 0
			end
		if player.checkerdistkill == nil
			player.checkerdistkill = 0
			end
		if not player.friction then player.friction = 0 end
		end
	end)

//Fix to friction thing
addHook("PlayerThink", function(p)
	if p.mo and p.mo.valid
		p.mo.friction = p.friction
	end
end)

addHook("PreThinkFrame", do
	for player in players.iterate
		if player.mo and player.unleashedphysenabler == true //and player.pflags & ~PF_FULLSTASIS
		
		local mo = player.mo
			
		if player.pflags & ~PF_FULLSTASIS
			if player.mo.skin == "modernsonic"
				//if player.cmd.buttons & BT_CUSTOM1
				if ((player.boosting == true) or (player.airboost == true))
					player.cancelboostvar = $ + 1
					player.driftboostcountervar = $ + 1
				else
					player.cancelboostvar = 0
					player.driftboostcountervar = 0
				end
			end
			if player.mo.skin == "adventuresonic"
			and player.YuRushMode ~= nil
				if player.cmd.buttons & BT_SPIN
				//and player.mo.state ~= S_PLAY_SPINDASH
				and player.YuRushMode.boosting
					player.cancelboostvar = $ + 1
					player.driftboostcountervar = $ + 1
				else
					player.cancelboostvar = 0
					player.driftboostcountervar = 0
				end
			end
			if player.mo.skin == "modernsonic"
				if player.cancelboostvar > 0
				and player.cancelboostvar < 2
				and P_IsObjectOnGround(player.mo)
				and (not (player.cmd.buttons & BT_ATTACK) or (player.cmd.buttons & BT_FIRENORMAL))
					if player.cmd.sidemove < -25
						P_InstaThrust(player.mo, player.mo.angle - ANGLE_45, 60*FRACUNIT)
					elseif player.cmd.sidemove > 25
						P_InstaThrust(player.mo, player.mo.angle + ANGLE_45, 60*FRACUNIT)
					elseif player.cmd.sidemove < 25
					and player.cmd.sidemove > -25
						return
					end
				end
				/*if player.driftboostcountervar > 0
				and player.driftboostcountervar < 2
				and player.driftmodealt
					if player.cmd.sidemove < -25
						P_InstaThrust(player.mo, player.mo.angle + ANG20, 60*FRACUNIT)
					elseif player.cmd.sidemove > 25
						P_InstaThrust(player.mo, player.mo.angle - ANG20, 60*FRACUNIT)
					elseif player.cmd.sidemove < 25
					and player.cmd.sidemove > -25
						return
					end
				end*/
			end
			if player.mo.skin == "adventuresonic"
				if player.cancelboostvar > 0
				and player.cancelboostvar < 2
				and P_IsObjectOnGround(player.mo)
				and (not (player.cmd.buttons & BT_ATTACK) or (player.cmd.buttons & BT_FIRENORMAL))
					if player.cmd.sidemove < -25
						P_InstaThrust(player.mo, player.mo.angle - ANGLE_90, 60*FRACUNIT)
					elseif player.cmd.sidemove > 25
						P_InstaThrust(player.mo, player.mo.angle + ANGLE_90, 60*FRACUNIT)
					elseif player.cmd.sidemove < 25
					and player.cmd.sidemove > -25
						return
					end
				end
			end
				/*if player.driftboostcountervar > 0
				and player.driftboostcountervar < 2
				and player.driftmodealt
					if player.cmd.sidemove < -25
						P_InstaThrust(player.mo, player.mo.angle + ANG20, 60*FRACUNIT)
					elseif player.cmd.sidemove > 25
						P_InstaThrust(player.mo, player.mo.angle - ANG20, 60*FRACUNIT)
					elseif player.cmd.sidemove < 25
					and player.cmd.sidemove > -25
						return
					end
				end*/
			end
		end
	end
end)

//Main hook
addHook("ThinkFrame", do
	for player in players.iterate
		if player.mo and player.unleashedphysenabler == true //and player.pflags & ~PF_FULLSTASIS
		
		local mo = player.mo
		local movingfactor = 4*FRACUNIT/11
		local movingfactor2 = 4*FRACUNIT/16
		local movingslowfactor = 0
		local momxyangle = R_PointToAngle2(player.mo.x, player.mo.y, (player.mo.x+player.mo.momx), (player.mo.y+player.mo.momy))
		local fixedmoveang = R_PointToAngle2(0, 0, mo.player.cmd.forwardmove*FRACUNIT, -mo.player.cmd.sidemove*FRACUNIT)
		local vnormalcamera = R_PointToAngle2(0, 0, mo.height - 7*FRACUNIT, mo.momz)
		local vnormalrotcamera = R_PointToAngle2(0, 0, mo.height - 1*FRACUNIT, mo.momz)
		local vspringcamera = R_PointToAngle2(0, 0, mo.height - 25*FRACUNIT, mo.momz)
		local vspringrotcamera = R_PointToAngle2(0, 0, mo.height - 8*FRACUNIT, mo.momz)
		local actualangleturnvar = player.cmd.angleturn<<16
	
	//Checks and counters 
if (not (P_IsObjectOnGround(player.mo)))
	player.isonairvar = 10
	player.isonairupvar = $ + 1
else
	player.isonairvar = $ - 1
	player.isonairupvar = 0
end

if not (player.driftmobj2 and player.driftmobj2.valid) then
	player.driftmobj2 = P_SpawnMobj(player.mo.x, player.mo.y, player.mo.z, MT_GFZFLOWER1)
	player.driftmobj2.flags2 = $1|MF2_DONTDRAW
	P_SetOrigin(player.driftmobj2, player.mo.x, player.mo.y, player.mo.z)
	player.driftmobj2.fuse = 65
elseif (player.driftmobj2 and player.driftmobj2.valid)
	P_SetOrigin(player.driftmobj2, player.mo.x, player.mo.y, player.mo.z)
end

/*if not (player.cameramobj and player.cameramobj.valid) then
	player.cameramobj = P_SpawnMobj(player.mo.x, player.mo.y, player.mo.z, MT_GFZFLOWER1)
	//player.cameramobj.flags2 = $1|MF2_DONTDRAW
	//P_SetOrigin(player.cameramobj, player.mo.x - 1, player.mo.y - 1, player.mo.z)
	//player.cameramobj.fuse = 65
elseif (player.cameramobj and player.cameramobj.valid)
	//P_SetOrigin(player.cameramobj, player.mo.x - 1, player.mo.y - 1, player.mo.z)
end

//cameramobj things
player.cameramobj.angle = momxyangle
player.cameramobj.momx = mo.momx
player.cameramobj.momy = mo.momy
player.cameramobj.momz = mo.momz*/

	player.prevpspeed2 = 10

if player.pflags & ~PF_FULLSTASIS
	//Special threat to EVERY character that breaks or have a weird function >:c
	if player.boosting == true
	//or DIDBOOST == true
	or ((player.isondriftvar == 1) and (player.speed > 77*FRACUNIT))
		player.beforeboostprevspd = 11
		player.boostanglechangervar = $ + 1
	else
		player.beforeboostprevspd = $ - 1
		player.boostanglechangervar = 0
	end
		if player.beforeboostprevspd == 11
		or player.beforeboostprevspd == 0
			player.localfriction2 = 32*FRACUNIT/32
		elseif player.beforeboostprevspd < 10
		and player.beforeboostprevspd > 0
			if player.driftmode
				if player.speed > 40*FRACUNIT
					player.localfriction2 = 28*FRACUNIT/32
				else
					player.localfriction2 = 32*FRACUNIT/32
					player.beforeboostprevspd = 0
				end
			else
				player.localfriction2 = 29*FRACUNIT/32
			end
		end
			if player.cmd.forwardmove == 0
			and ((player.beforeboostprevspd < 10) or (player.beforeboostprevspd > 0))
				player.localfriction2 = 29*FRACUNIT/32
			elseif ((player.cmd.forwardmove ~= 0) or (player.cmd.sidemove ~= 0))
			and ((player.beforeboostprevspd == 11) or (player.beforeboostprevspd <= 0))
				player.localfriction2 = 32*FRACUNIT/32
			end
			
	if player.mo.skin == "modernsonic"
		if player.boosting == false
			and player.speed > 42*FRACUNIT
			and P_IsObjectOnGround(player.mo)
			and player.beforeboostprevspd <= 0
			and not ((player.powers[pw_sneakers]) or (player.powers[pw_super]))
				player.localfriction2 = 29*FRACUNIT/32
			//end
		end
	end
	
	if player.mo.skin == "adventuresonic"
		if mo.state == S_PLAY_ROLL
		or ((mo.state == S_PLAY_SPINDASH) and (player.isondriftvar == 0))
		and P_IsObjectOnGround(player.mo)
			player.hspringcamc = $ + 1
		else
			player.hspringcamc = 0
		end
	end
	
	if (not (P_IsObjectOnGround(player.mo)))
		if player.airboost == true
			player.aerealboostvar = $ + 1
		else
			player.aerealboostvar = 0
		end
		if player.aerealboostvar == 1
			mo.angle = momxyangle
			player.drawangle = mo.angle
		end
	end
	
	if player.noxmomchar
	and player.mo.skin == "modernsonic"
		player.noxmomchar = 2
	end
	
	if player.cmd.forwardmove < -47
		player.friction = 30*FRACUNIT/32
	end
end	
	
//Analog sens while aren't running
	if player.analogsens == true
	and player.pflags & ~PF_FULLSTASIS
	and not (player.mo.flags2 & MF2_TWOD)
		if P_IsObjectOnGround(player.mo)
			if player.speed < 25*FRACUNIT
			and player.cmd.forwardmove > 0
				if player.cmd.sidemove > -14
				and player.cmd.sidemove < 14
					/*if player.mo.skin ~= "adventuresonic"
						player.moveallfactor = movingslowfactor //+ 1*FRACUNIT/4
					else
						player.moveallfactor = movingslowfactor //+ 2*FRACUNIT/3
					end*/
					player.localfriction2 = 29*FRACUNIT/32
					player.friction = player.localfriction2
					mo.angle = player.angleholdervar
					player.drawangle = mo.angle
					//mo.movefactor = player.moveallfactor
					//P_Thrust(player.mo, mo.angle, FRACUNIT/2)
				end
			end
			if player.cmd.forwardmove > 0
			and player.cmd.sidemove > -14
			and player.cmd.sidemove < 14
				player.angleholdercounter = $ + 1
				if player.angleholdercounter == 1
				//or player.speed < 1*FRACUNIT
					player.angleholdervar = player.cmd.angleturn<<16
				end
				actualangleturnvar = player.angleholdervar
			else
				player.angleholdercounter = 0
				player.angleholdervar = player.cmd.angleturn<<16
			end
			if player.angleholdercounter > 10
				player.angleholdercounter = 10
			end
		end
		if (not (P_IsObjectOnGround(player.mo)))
			player.angleholdervar = actualangleturnvar
		end
	end
	
	if player.isondriftvar == 0
		player.modspeed = player.speed
	end
	
	//Movement outside forward input!
	if player.mo.skin ~= "adventuresonic"
	and player.isondriftvar ~= 1
	and player.mo.flags & ~MF_SLIDEME
	and player.boosting == false
		if P_IsObjectOnGround(player.mo)
			if player.cmd.forwardmove < -25
			and (not (player.cmd.forwardmove < -40))
			and player.speed > 21*FRACUNIT
			and player.speed < 37*FRACUNIT
				if ((player.isonquickstep == 0) or (player.isonquickstep == nil))
					mo.angle = momxyangle
				end
				if player.speed < 36*FRACUNIT
				and (not (player.cmd.forwardmove < -44))
					P_Thrust(player.mo, momxyangle, 10*FRACUNIT/4)
				end
			end
	
			if player.cmd.forwardmove < -40
			and (not (player.cmd.forwardmove < -44))
			/*and player.cmd.sidemove > -8
			and player.cmd.sidemove < 8*/
			and player.speed > 21*FRACUNIT
			and player.speed < 37*FRACUNIT
				if ((player.isonquickstep == 0) or (player.isonquickstep == nil))
					mo.angle = momxyangle
					player.drawangle = momxyangle
				end
				mo.friction = 64488
				mo.movefactor = movingfactor2
				if player.speed < 36*FRACUNIT
				and (not (player.cmd.forwardmove < -44))
				//and (not (player.cmd.sidemove > 14))
					if player.groundfrictionchecker >= 61392
						if player.speed < 34*FRACUNIT
							P_InstaThrust(player.mo, momxyangle, player.speed)
						end
					else
						P_Thrust(player.mo, momxyangle, 10*FRACUNIT/4)
					end
				end
			end
	
			if player.cmd.forwardmove < -48
			and player.speed > 21*FRACUNIT
			and ((player.isonquickstep == 0) or (player.isonquickstep == nil))
				mo.angle = momxyangle
			end
	
			if player.cmd.forwardmove > -25
			and player.cmd.forwardmove < 8
			and player.cmd.sidemove ~= 0
			and player.speed > 21*FRACUNIT
			//and player.speed < 37*FRACUNIT
				player.friction = 64488
				mo.movefactor = movingfactor2
				mo.angle = momxyangle
				if player.speed < 36*FRACUNIT
					if player.groundfrictionchecker >= 61392
						if player.speed < 34*FRACUNIT
							P_InstaThrust(player.mo, momxyangle, player.speed)
						end
					else
						P_Thrust(player.mo, momxyangle, 10*FRACUNIT/5)
					end
					//P_Thrust(player.mo, momxyangle, 20*FRACUNIT/5)
				end
			end
		end
		
		if player.beforeboostprevspd == 1
		and player.cmd.forwardmove < -48
			mo.angle = momxyangle
			player.drawangle = momxyangle
		end
	
		if mo.eflags & MFE_UNDERWATER
		and P_IsObjectOnGround(player.mo)
		and player.cmd.forwardmove > 15
			P_Thrust(player.mo, mo.angle, 1*FRACUNIT/4)
		end
	end
	
//Acceleration changes
	if player.acceleration
		player.acceleration = 27
	end
	if player.accelstart
		player.accelstart = 116
	end
	
	//The camera part
	if player.mo and player.pflags & ~PF_FULLSTASIS
		if P_IsObjectOnGround(player.mo)
		and ((player.quickstep1 == 0) or (player.quickstep1 == nil) or (player.quickstep1 ~= 1))
		and player.isondriftvar == 0
		and player.hspringcamc == 0
		and (not (player.cmd.forwardmove < -40))
		and not (player.mo.flags2 & MF2_TWOD)
			if player.speed > 25*FRACUNIT
				if ((player.isonquickstep == 0) or (player.isonquickstep == nil))
					mo.angle = momxyangle
					player.drawangle = mo.angle
				end
				if player.analogsens == true
					if player.cmd.sidemove > -14
					and player.cmd.sidemove < 14
						player.moveallfactor = movingslowfactor
						if player.mo.skin == "modernsonic"
							if player.speed < 40*FRACUNIT
								P_Thrust(player.mo, mo.angle, 1*FRACUNIT/4)
							end
						else
							P_Thrust(player.mo, mo.angle, 1*FRACUNIT/4)
						end
					else
						if player.mo.skin == "modernsonic"
							if player.speed < 70*FRACUNIT
								player.moveallfactor = movingfactor2
							elseif player.speed > 69*FRACUNIT
								player.moveallfactor = 4*FRACUNIT/24
							end
						else
							player.moveallfactor = movingfactor2
						end
					end
					if player.cmd.sidemove > 14
					or player.cmd.sidemove < -14
						if ((player.beforeboostprevspd == 11) or (player.beforeboostprevspd <= 0))
							player.localfriction2 = 64488
						else
							player.localfriction2 = 28*FRACUNIT/32
						end
					end
				else
					player.moveallfactor = movingfactor2
				end
				player.friction = player.localfriction2
				mo.movefactor = player.moveallfactor
			end
			player.normalcamc = true
		else
			player.normalcamc = false
		end
		//Old vertical camera
		local string2 = CV_FindVar("cam_orbit")
		/*if player.vcameramode == false
		and player.vcameramodealt == false
			if player.isonairvar == 10
				if mo.state == S_PLAY_SPRING
					if string2.value == 0
						player.aiming = vspringcamera
					elseif string2.value == 1
						player.aiming = vspringrotcamera
						if player.aiming < -200000000
							player.aiming = -200000000
						end
					end
				else
					if string2.value == 0
						player.aiming = vnormalcamera
					elseif string2.value == 1
						player.aiming = vnormalrotcamera
						if player.aiming < -200000000
						player.aiming = -200000000
						end
					end
				end
				if player.stomping == true
					if string2.value == 0
						player.aiming = vspringcamera
					elseif string2.value == 1
						player.aiming = vspringrotcamera
						if player.aiming < -300000000
							player.aiming = -300000000
						end
					end
				end
			elseif player.isonairvar == 9
				player.aiming = 0
			end
		end*/
		//New vertical camera
		if player.vcameramode
		or player.vcameramodealt
			if player.isonairvar == 9
				player.aiming = 0
			end
			if player.checkerdistkill == 0
				player.campdistchecker = R_PointToDist2(0, mo.momz, 0, camera.momz)
			end
			if player.isonairvar == 10
				if player.pflags & PF_JUMPED
				and player.sprungcounter <= 0
				and player.finishedtrick ~= true
				and player.jumpheldcv > 0
					player.isonjumpv = $ + 1
					if (not (camera.z <= camera.subsector.sector.floorheight))
						camera.z = $ - 780000
					end
				else
					camera.z = $ - mo.momz/3 // $ - 200000
					player.isonjumpv = 0
				end
				if player.isonjumpv <= 7
				and player.pflags & PF_JUMPED
				and player.sprungcounter <= 0
				and player.finishedtrick ~= true
				and player.jumpheldcv > 0
					camera.z = player.camzholder
					camera.aiming = 0
				end
				camera.aiming = $/2
				if camera.z > camera.subsector.sector.floorheight
					camera.momz = $/2
				end
				if player.jumpheldcv < 46
					if mo.momz < -1154774
					and player.sprungcounter <= 0
						camera.z = mo.z + 6975000
					/*elseif mo.momz > 1654774
					and player.sprungcounter <= 0
						camera.z = mo.z - 227500*/
					end
					/*if camera.momz < -1654774
						camera.z = mo.z + 5750000
					elseif camera.momz > 25*FRACUNIT
						camera.z = mo.z - 197500 // - 4028000
					end*/
					/*if player.campdistchecker > 2800000
						if mo.momz < -3*FRACUNIT
							camera.z = mo.z + 6750000
							player.checkerdistkill = 1
						end
					end*/
				end
				if player.isonjumpv > 14
					/*if mo.momz < -13*FRACUNIT/3
						camera.z = $ + 450000
					elseif mo.momz > 13*FRACUNIT/3
						camera.z = $ - 450000
					end*/
					if mo.momz > -814774
						camera.z = $ - mo.momz
					elseif mo.momz < -804774
						camera.z = mo.z + 5375000
					end
				end
				if player.pflags & PF_STARTJUMP
					player.jumpheldcv2 = $ + 1
				else
					player.jumpheldcv2 = 0
				end
				if player.jumpheldcv2 == 1
					player.jumpheldcv = 75
				else
					player.jumpheldcv = $ - 1
				end
				if player.jumpheldcv > 46
				and camera.z > camera.subsector.sector.floorheight
				or ((mo.momz > 12*FRACUNIT/8) and (player.isonairupvar > 9) and (mo.momz < 25*FRACUNIT) and (camera.z > camera.subsector.sector.floorheight))
					camera.z = $ - 280000
				end
				if camera.z <= camera.subsector.sector.floorheight + 10000
				//or ((camera.z <= camera.subsector.sector.f_slope.zdelta + 100000) and (camera.subsector.sector.f_slope.zdelta ~= nil))
					if player.jumpheldcv > 40
						camera.z = mo.z --camera.subsector.sector.floorheight + 25000000
						camera.momz = mo.momz
					end
					//print("The camera is touchin floor")
				end
			else
				player.camzchanger = camera.z
				player.camzholder = camera.z
				player.isonjumpv = 0
				player.jumpheldcv = 0
				player.jumpheldcv2 = 0
				player.cameraangstore = camera.aiming
				player.groundmomzh = mo.z
				player.checkerdistkill = 0
			end
		end
		//FOV changes
		//Only for Modern Sonic
		local oglfovlocal = CV_FindVar("gr_fovchange") or CV_FindVar("fovchange")
		if oglfovlocal.value == 0
		and ((player.vcameramodealt) or (player.vcameramodealt2))
			COM_BufInsertText(player, "camerachanges on")
			CONS_Printf(player, "You need to activate gr_fovchange before this.")
		end
		if player.vcameramodealt
		or player.vcameramodealt2
		and oglfovlocal.value == 1
			if player.springc == nil
				if player.fovadd > 1550000
				and player.isrunningvar < 23
					player.fovadd = 1550000
				end
			elseif player.springc ~= nil
				if player.springc < 1
					if player.fovadd > 1550000
					and player.isrunningvar < 23
						player.fovadd = 1550000
					end
				end
			end
			if player.speed > 60*FRACUNIT
			and (((player.boosting == true) and (player.boosting ~= nil)) or ((player.airboost == true) and (player.airboost ~= nil)))
				player.isrunningvar = $ + 1
				player.isrunningvar2 = 20
				if player.isrunningvar < 23
					player.fovchanger = player.fovadd
					player.fovchanger2 = player.fovchanger
				end
			else
				player.isrunningvar = 0
				player.isrunningvar2 = $ - 1
			end
			if player.isrunningvar > 23
				if player.isrunningvar < 58
					if player.fovadd > 0
						player.fovchanger = $ - 65000
					elseif player.fovadd < 0
						player.fovchanger = $ - 15750
					end
					player.fovchanger2 = player.fovchanger
				end
				player.fovadd = player.fovchanger
				if player.fovadd < -50000
					player.fovadd = -50000
				end
				if player.fovchanger < -50000
					player.fovchanger = -50000
				end
			end
			if player.isrunningvar2 > 0
			and player.isrunningvar == 0
			and player.fovchanger2 < 10000
			and (((player.boosting == false) and (player.boosting ~= nil)) or ((player.airboost == false) and (player.airboost ~= nil)))
				player.fovadd = player.fovchanger
				if player.speed > 25*FRACUNIT
					player.fovchanger = $ + 35120
				end
			end
		end
		//Quickstep changes
		 
		//End of camera part
	end
	
	//Drift part
	if player.mo and player.mo.valid 
	and player.pflags & ~PF_FULLSTASIS
	and player.pflags & ~PF_SLIDING
	and not (player.mo.flags2 & MF2_TWOD)
		if ((player.cmd.buttons & BT_ATTACK) or (player.cmd.buttons & BT_FIRENORMAL) or ((player.cmd.buttons & BT_SPIN) and player.mo.skin ~= "adventuresonic" and player.driftmode))
		//and ((((player.cmd.sidemove > 20) or (player.cmd.sidemove < -20)) and (player.analogsens == true)) or (((player.cmd.sidemove > 15) or (player.cmd.sidemove < -15)) and (player.analogsens == false)) or (((player.cmd.sidemove > 15) or (player.cmd.sidemove < -15)) and (player.analogsens == nil)))
		and P_IsObjectOnGround(player.mo)
		and ((player.cmd.sidemove > 10) or (player.cmd.sidemove < -10))
		and P_PlayerInPain(player) == false
		and player.speed > 15*FRACUNIT
		and player.driftlagvar == 0
			if player.mo.skin == "modernsonic"
			//and (not (player.cmd.buttons & BT_SPIN))
				if player.boosting == true
					mo.angle = momxyangle
					if player.driftmodealt
						mo.movefactor = 6*FRACUNIT/8
					end
					//player.localfriction2 = 23*FRACUNIT/32
					player.isondriftvar = 1
					player.driftcooldown = 0
					player.unldriftcounter = $ + 1
					//player.wasdrifting = 1
				elseif player.boosting == false
					mo.angle = momxyangle
					mo.movefactor = 3*FRACUNIT/5
					//player.localfriction2 = 32*FRACUNIT/32
					player.isondriftvar = 1
					player.driftcooldown = 0
					player.unldriftcounter = $ + 1
					//player.wasdrifting = 1
				end
			else
				mo.state = S_PLAY_ALLDRIFT
				player.isdriftingvar = $ + 1
				player.isdriftdustvar = $ + 1
				player.unldriftcounter = $ + 1
				//player.wasdrifting = 1
					if player.isdriftingvar > 6
						S_StartSound(player.driftmobj2, sfx_drft2)
					end
					if player.isdriftdustvar == 2
						local dust1 = P_SpawnMobjFromMobj(player.realmo, P_RandomRange(-10, 10) * FRACUNIT, P_RandomRange(-10, 10) * FRACUNIT, 0, MT_SPINDUST)							
						dust1.momx = P_RandomRange(-4, 4)*FRACUNIT
						dust1.momy = P_RandomRange(-4, 4)*FRACUNIT
						dust1.momz = P_RandomRange(0, 4)*FRACUNIT
						dust1.destscale = FRACUNIT/2
							
						local dust2 = P_SpawnMobjFromMobj(player.realmo, P_RandomRange(-10, 10) * FRACUNIT, P_RandomRange(-10, 10) * FRACUNIT, 0, MT_SPINDUST)							
						dust2.momx = P_RandomRange(-4, 4)*FRACUNIT
						dust2.momy = P_RandomRange(-4, 4)*FRACUNIT
						dust2.momz = P_RandomRange(0, 4)*FRACUNIT
						dust2.destscale = FRACUNIT/2
							
						local dust3 = P_SpawnMobjFromMobj(player.realmo, P_RandomRange(-10, 10) * FRACUNIT, P_RandomRange(-10, 10) * FRACUNIT, 0, MT_SPINDUST)							
						dust3.momx = P_RandomRange(-4, 4)*FRACUNIT
						dust3.momy = P_RandomRange(-4, 4)*FRACUNIT
						dust3.momz = P_RandomRange(0, 4)*FRACUNIT
						dust3.destscale = FRACUNIT/2
							
						local dust4 = P_SpawnMobjFromMobj(player.realmo, P_RandomRange(-10, 10) * FRACUNIT, P_RandomRange(-10, 10) * FRACUNIT, 0, MT_SPINDUST)							
						dust4.momx = P_RandomRange(-4, 4)*FRACUNIT
						dust4.momy = P_RandomRange(-4, 4)*FRACUNIT
						dust4.momz = P_RandomRange(0, 4)*FRACUNIT
						dust4.destscale = FRACUNIT/2
							
						local dust5 = P_SpawnMobjFromMobj(player.realmo, P_RandomRange(-10, 10) * FRACUNIT, P_RandomRange(-10, 10) * FRACUNIT, 0, MT_SPINDUST)							
						dust5.momx = P_RandomRange(-4, 4)*FRACUNIT
						dust5.momy = P_RandomRange(-4, 4)*FRACUNIT
						dust5.momz = P_RandomRange(0, 4)*FRACUNIT
						dust5.destscale = FRACUNIT/2
					end
					if player.isdriftingvar >= 7
						player.isdriftingvar = 0
					end
					if player.isdriftdustvar > 2
						player.isdriftdustvar = 0
					end
				mo.angle = momxyangle
				player.drawangle = momxyangle
				//player.localfriction2 = 32*FRACUNIT/32
				if player.speed < 70*FRACUNIT
					mo.movefactor = 3*FRACUNIT/5
				end
				player.isondriftvar = 1
				player.driftcooldown = 0
				if player.pflags & ~PF_SPINNING
					player.pflags = $1 & ~PF_SPINNING
				end
			end
			player.friction = player.localfriction2
		else
			player.isondriftvar = 0
			player.driftcooldown = $ + 1
			S_StopSound(player.driftmobj2)
			//player.wasdrifting = 0
		end
	end
	
	if player.driftcooldown == 1
		player.driftlagvar = 10
	else
		player.driftlagvar = $ - 1
	end
	if player.driftlagvar == 10
		player.wasdrifting = 1
	end
	if player.driftlagvar <= 0
		player.wasdrifting = 0
	end
	/*if player.driftlagvar > 0
		mo.state = S_PLAY_DRIFTEND
	end*/
	
	if player.driftmode
		if player.isondriftvar == 1
			UnleashedDrift(mo)
			if player.speed < 39*FRACUNIT
			and player.speed > 1*FRACUNIT
				player.friction = 34*FRACUNIT/32
			end
			if player.speed < 46*FRACUNIT
			and player.speed > 39*FRACUNIT
				mo.movefactor = 3*FRACUNIT/7
				player.friction = 32*FRACUNIT/32
			end
			if player.speed < 70*FRACUNIT
			and player.speed > 46*FRACUNIT
				mo.movefactor = 3*FRACUNIT/9
				player.friction = 31*FRACUNIT/32
			end
			if player.speed > 70*FRACUNIT
			and player.speed < 86*FRACUNIT
				mo.movefactor = 100
			elseif player.speed > 86*FRACUNIT
			and player.speed < 96*FRACUNIT
				mo.movefactor = 0
			elseif player.speed > 96*FRACUNIT
				mo.movefactor = 0
			elseif player.mo.skin == "modernsonic"
			and player.boosting == true
				mo.movefactor = 0
				P_Thrust(player.mo, mo.angle, 12*FRACUNIT)
			end
			if player.speed > 119*mo.scale*1
				player.friction = 32*FRACUNIT/32
			end
		end
	elseif player.driftmodealt
		if (not ((player.cmd.buttons & BT_ATTACK) or (player.cmd.buttons & BT_FIRENORMAL)))
		//if player.wasdrifting == 0
			player.driftjumpvar = 0
			player.jumperfixer = 0
		else
			player.jumperfixer = $ + 1
		end
		if player.jumperfixer == 1
			player.jumperfixer2 = 10
		else
			player.jumperfixer2 = $ - 1
		end
		if player.jumperfixer2 > 0
			player.driftstomper = $ + 1
		else
			player.driftstomper = 0
		end
		if player.cmd.buttons & BT_JUMP 
		or player.lastbuttons & BT_JUMP
			player.driftstomper = 0
		end
		if player.isondriftvar == 1
			UnleashedDrift(mo)
			if player.speed < 39*FRACUNIT
			and player.speed > 1*FRACUNIT
				player.friction = 34*FRACUNIT/32
			end
			if player.speed > 39*FRACUNIT
			and player.speed < 70*FRACUNIT
				player.friction = 30*FRACUNIT/32
			end
			player.driftjumpvar = $ + 1
			if player.driftjumpvar == 1
				//P_DoJump(player, (true))
				mo.state = S_PLAY_DRIFTJUMP
				if player.mo.skin == "modernsonic"
					S_StartSound(player.mo, sfx_mjump)
					if mo.eflags & MFE_UNDERWATER
						P_SetObjectMomZ(player.mo, 4*FRACUNIT)
					else
						P_SetObjectMomZ(player.mo, 8*FRACUNIT)
					end
				else
					S_StartSound(player.mo, sfx_jump)
					if mo.eflags & MFE_UNDERWATER
						P_SetObjectMomZ(player.mo, 3*FRACUNIT)
					else
						P_SetObjectMomZ(player.mo, 7*FRACUNIT)
					end
				end
			end
		end
		//if player.cmd.buttons & BT_CUSTOM2
		/*if player.driftstomper > 6
		or player.cmd.buttons & BT_CUSTOM2
		and player.isonairupvar < 13
		and P_PlayerInPain(player) == false
		and mo.state ~= S_PLAY_SPRING
		and player.sprungcounter <= 0
		and abs(mo.momz)
			//player.mo.momz = FixedMul(-50*FRACUNIT, mo.scale)
			//P_SetObjectMomZ(player.mo, FixedMul(-30*FRACUNIT, mo.scale), true)
			player.mo.momz = $ + FixedMul(P_GetMobjGravity(player.mo), 30*FRACUNIT/12)
			//mo.movefactor = 1*FRACUNIT/12
		end*/
		if ((P_IsObjectOnGround(player.mo)) and (player.driftstomper > 9))
			player.driftstomper = 11
		end
		if mo.state == S_PLAY_DRIFTJUMP
		and P_PlayerInPain(player) == false
		and player.sprungcounter <= 0
			if mo.eflags & MFE_UNDERWATER
				player.mo.momz = $ + FixedMul(P_GetMobjGravity(player.mo), 38*FRACUNIT/12)
			else
				player.mo.momz = $ + FixedMul(P_GetMobjGravity(player.mo), 30*FRACUNIT/12)
			end
		end
		if player.driftstomper == 9
			player.isdriftingvar = 7
			player.driftsens = 7
		end
	elseif player.driftmodealt2
		if player.isondriftvar == 1
			UnleashedDrift(mo)
			if player.speed < 39*FRACUNIT
			and player.speed > 1*FRACUNIT
				player.friction = 34*FRACUNIT/32
			end
			if player.speed > 39*FRACUNIT
			and player.speed < 70*FRACUNIT
				player.friction = 30*FRACUNIT/32
			end
		end
	else
		if player.isondriftvar == 1
			SimpleDrift(mo)
			if player.cmd.buttons & BT_SPIN
				if player.speed < 55*FRACUNIT
				and player.mo.skin ~= "adventuresonic"
					mo.movefactor = 3*FRACUNIT/5
					player.localfriction2 = 32*FRACUNIT/32
				else
					mo.movefactor = 6*FRACUNIT/8
					player.localfriction2 = 23*FRACUNIT/32
				end
			else
				mo.movefactor = 3*FRACUNIT/5
				player.localfriction2 = 32*FRACUNIT/32
			end
		end
	end
	
	//Air Drag
	//For characters who doesn't have it
	if player.airchanges == true
	and player.pflags & ~PF_FULLSTASIS
		//if (not (P_IsObjectOnGround(player.mo)))
		if player.pflags & PF_JUMPED
		//and player.mo.eflags & ~MFE_ONGROUND
			//if player.mo.skin ~= "modernsonic"
			if player.mo.skin ~= "adventuresonic"
				if player.speed > 30*FRACUNIT
				and player.speed < 62*FRACUNIT
					mo.momx = FixedDiv(FixedMul($, 96), 99)
					mo.momy = FixedDiv(FixedMul($, 96), 99)
				elseif player.speed > 62*FRACUNIT
					mo.momx = FixedDiv(FixedMul($, 96), 102)
					mo.momy = FixedDiv(FixedMul($, 96), 102)
				end
				if player.stomping == true
					if player.speed > FRACUNIT
						mo.momx = FixedDiv(FixedMul($, 96), 104)
						mo.momy = FixedDiv(FixedMul($, 96), 104)
					end
				end
			end
		end
		
		//SRB2 needs better checks for things like this
		if mo.eflags & MFE_SPRUNG
			player.sprungcounter = 50
		else
			player.sprungcounter = $ - 1
		end
		if P_IsObjectOnGround(player.mo)
			player.sprungcounter = 0
		end
	
		//Higher gravity and higher jumps
		//Only for specific things
		if player.mo.flags & ~MF_NOGRAVITY
		and player.pflags & ~PF_FULLSTASIS
		and player.pflags & PF_JUMPED
		//and player.pflags & PF_JUMPDOWN
		and mo.eflags & ~MFE_UNDERWATER
		and player.sprungcounter <= 0	--SRB2 really needs better checks for things like this -_-
		and P_PlayerInPain(player) == false
		and abs(mo.momz)
			player.mo.momz = $ + FixedMul(P_GetMobjGravity(player.mo), 6*FRACUNIT/12)
		end
		if player.jumpfactor == skins[player.mo.skin].jumpfactor
			player.jumpfactor = FixedMul($, 7*FRACUNIT / 5)
		end
	end
	
		//Insert here rail grind special threat to make it more functional lol
		//if mo.state == S_PLAYER_GRINDING
		if player.railthistic ~= nil
		and player.rail ~= nil
		and player.railthistic == true
		and player.rail == line
		and player.speed > 4*FRACUNIT
		and player.pflags & ~PF_FULLSTASIS
			mo.angle = momxyangle
			player.drawangle = momxyangle
			player.localfriction2 = 29*FRACUNIT/32
		end
		
		if P_IsObjectOnGround(player.mo)
			if mo.subsector.sector.friction
				player.groundfrictionchecker = mo.subsector.sector.friction
			end
			if player.groundfrictionchecker >= 61392
				if player.cmd.forwardmove > 0
				and player.speed < 40*FRACUNIT
				and player.speed > 21*FRACUNIT
					P_Thrust(player.mo, momxyangle, 4*FRACUNIT/9)
				end
			end
		end
			
		if player.isonairvar > 10
			player.isonairvar = 10
			end
		if player.sprungcounter < 0
			player.sprungcounter = 0
			end
		if player.jumperfixer2 < 0
			player.jumperfixer2 = 0
			end
		if player.driftjumpvar > 15
			player.driftjumpvar = 15
			end
		if player.cancelboostvar > 10
			player.cancelboostvar = 10
			end
		if player.aerealboostvar > 10
			player.aerealboostvar = 10
			end
		if player.isrunningvar2 < 0
			player.isrunningvar2 = 0
			end
		if player.driftcooldown < 0
			player.driftcooldown = 0
			end
		if player.driftlagvar < 0
			player.driftlagvar = 0
			end
		if player.driftcooldown > 35
			player.driftcooldown = 35
			end
		if player.driftlagactivator < 0
			player.driftlagactivator = 0
			end
		if player.jumpheldcv < 0
			player.jumpheldcv = 0
			end
		end
	end
end)

addHook("PlayerSpawn", function(p)
	if io and p == consoleplayer and p.unleashedphysenabler == nil
		local file = io.openlocal("client/unlphys.dat")
		if file
			local string = file:read("*a")
			if string == "1" or string == "true" or string == "on"
				COM_BufInsertText(p, "unleashedphys on")
			elseif string == "0" or string == "false" or string == "off"
				COM_BufInsertText(p, "unleashedphys off")
			elseif string == nil
				COM_BufInsertText(p, "unleashedphys off")
			end
			file:close()
		else
			COM_BufInsertText(p, "unleashedphys on")
		end
	end
end)

addHook("PlayerSpawn", function(p)
	if io and p == consoleplayer and p.analogsens == nil
		local file = io.openlocal("client/analogsens.dat")
		if file
			local string = file:read("*a")
			if string == "1" or string == "true" or string == "gens" or string == "unwiished" or string == "on"
				COM_BufInsertText(p, "analogsens on")
			elseif string == "0" or string == "false" or string == "vanilla" or string == "off"
				COM_BufInsertText(p, "analogsens off")
			elseif string == nil
				COM_BufInsertText(p, "analogsens off")
			end
			file:close()
		else
			COM_BufInsertText(p, "analogsens on")
		end
	end
end)

addHook("PlayerSpawn", function(p)
	if io and p == consoleplayer and p.driftmode == nil
		local file = io.openlocal("client/driftmode.dat")
		if file
			local string = file:read("*a")
			if string == "1" or string == "true" or string == "unleashed" or string == "unwiished" or string == "on"
				COM_BufInsertText(p, "driftmode on")
			elseif string == "0" or string == "false" or string == "off"
				COM_BufInsertText(p, "driftmode off")
			elseif string == "2" or string == "alt" or string == "fixed" or string == "gens"
				COM_BufInsertText(p, "driftmode alt")
			elseif string == "3" or string == "alt2" or string == "gensnojump"
				COM_BufInsertText(p, "driftmode alt2")
			elseif string == nil
				COM_BufInsertText(p, "driftmode on")
			end
			file:close()
		else
			COM_BufInsertText(p, "driftmode on")
		end
	end
	p.driftcooldown = 35
end)

addHook("PlayerSpawn", function(p)
	if io and p == consoleplayer and p.airchanges == nil
		local file = io.openlocal("client/airchanges.dat")
		if file
			local string = file:read("*a")
			if string == "1" or string == "true" or string == "on"
				COM_BufInsertText(p, "airchanges on")
			elseif string == "0" or string == "false" or string == "off"
				COM_BufInsertText(p, "airchanges off")
			elseif string == nil
				COM_BufInsertText(p, "airchanges off")
			end
			file:close()
		else
			COM_BufInsertText(p, "airchanges on")
		end
	end
end)

addHook("PlayerSpawn", function(p)
	if io and p == consoleplayer and p.vcameramode == nil
		local file = io.openlocal("client/vcamera.dat")
		if file
			local string = file:read("*a")
			if string == "1" or string == "true" or string == "on"
				COM_BufInsertText(p, "camerachanges on")
			elseif string == "0" or string == "false" or string == "off"
				COM_BufInsertText(p, "camerachanges off")
			elseif string == "2" or string == "alt" or string == "unleashed"
				COM_BufInsertText(p, "camerachanges alt")
			elseif string == "3" or string == "alt2" or string == "fovonly"
				COM_BufInsertText(p, "camerachanges alt2")
			elseif string == nil
				COM_BufInsertText(p, "camerachanges on")
			end
			file:close()
		else
			COM_BufInsertText(p, "camerachanges alt")
		end
	end
end)

addHook("PostThinkFrame", do
	for player in players.iterate
		if player.mo and player.unleashedphysenabler == true //and player.pflags & ~PF_FULLSTASIS
		
	local mo = player.mo
	local fixedmove = R_PointToAngle2(0, 0, mo.player.cmd.forwardmove*FRACUNIT, -mo.player.cmd.sidemove*FRACUNIT)
	local angle = R_PointToAngle2(mo.x, mo.y, (mo.x+mo.momx), (mo.y+mo.momy))
	local inputangle = angle + fixedmove
	local angleo50 = ANG64h - ANG10 - ANG1
	local angleo51 = ANG64h - ANG10 - ANG2 - ANG1 - ANG1 - ANG1
	local diparate = 1 + 1/4
	
		if (not (P_IsObjectOnGround(player.mo)))
		and player.pflags & ~PF_FULLSTASIS
			player.wallcounterc = false
		end
			if player.mo.skin ~= "adventuresonic"
			and player.mo.skin ~= "modernsonic"
			and player.pflags & ~PF_FULLSTASIS
				MomentumLimiter(mo,svr)
				if player.speed > 77*mo.scale*1
					if player.isondriftvar == 0
					and player.mo.skin ~= "modernsonic" --Stupid fail fix
					and player.pflags & ~PF_FULLSTASIS
						if player.cmd.sidemove > 14
						or player.cmd.sidemove < -14
							player.friction = 30*FRACUNIT/32
							mo.movefactor = 1*FRACUNIT/4
						else
							mo.friction = 32*FRACUNIT/32
							player.movefactor = 0
						end
					end
				end
			end
			
		if player.mo.skin == "modernsonic"
		and player.pflags & ~PF_FULLSTASIS
			if player.driftjumpvar > 0
			and (not (P_IsObjectOnGround(player.mo)))
			and (not (P_PlayerInPain(player)))
				if player.boosting == true
					if player.mo.state ~= S_PLAY_DRIFTJUMP
						mo.state = S_PLAY_DRIFTJUMP
					end
				end
			end
		end
		
		if player.isrunningvar > 23
			if player.fovadd < 0
				player.camerascale = 65488
			end
		end
		
		 //player.checkerdistkill = 0
		 
			/*if MomentumLimiter(mo,svr) == true
				player.momentumkillercounter = $ + 1
			else
				player.momentumkillercounter = 0
			end
			if player.momentumkillercounter == 1
				player.momentumkillercounter2 = 18
			else
				player.momentumkillercounter2 = $ - 1
			end*/
				
				//Momentum killer
				//I hate mom mods -_-
				/*insert momentum actual killer here*/
				
			//if ((player.cmd.buttons & BT_ATTACK) or (player.cmd.buttons & BT_FIRENORMAL) or (player.cmd.buttons & BT_SPIN))
			if player.mo.state == S_PLAY_ALLDRIFT and player.pflags & ~PF_FULLSTASIS
			or ((player.isondriftvar == 1) and (player.mo.state == S_PLAY_SPINDASH) and (player.mo.skin == "modernsonic"))
				if player.cmd.sidemove < 0
					player.drawangle = $ + ANG30
				elseif player.cmd.sidemove > 0
					player.drawangle = $ - ANG30
				end
			end
		end
	end
end)

//Debug thing.
hud.add(function(v)
	for player in players.iterate do
		if player.debugthings1 == true
			v.drawNum(370, 10, player.cmd.angleturn<<16, V_ORANGEMAP|V_30TRANS)
			v.drawNum(370, 20, player.aiming, V_ORANGEMAP|V_30TRANS)
			v.drawNum(370, 30, player.speed, V_ORANGEMAP|V_30TRANS)
			v.drawNum(370, 40, player.mo.friction, V_ORANGEMAP|V_30TRANS)
			v.drawNum(370, 50, player.mo.movefactor, V_ORANGEMAP|V_30TRANS)
			v.drawNum(370, 60, player.angleholdervar, V_ORANGEMAP|V_30TRANS)
			v.drawNum(370, 70, player.mo.angle, V_ORANGEMAP|V_30TRANS)
			v.drawNum(370, 80, player.mo.momz, V_ORANGEMAP|V_30TRANS)
			v.drawNum(370, 90, player.sprungcounter, V_ORANGEMAP|V_30TRANS)
			v.drawNum(370, 100, player.cmd.sidemove, V_ORANGEMAP|V_30TRANS)
			v.drawNum(370, 110, player.cmd.forwardmove, V_ORANGEMAP|V_30TRANS)
			v.drawNum(370, 120, camera.momz, V_ORANGEMAP|V_30TRANS)
			v.drawNum(370, 130, player.camerascale, V_ORANGEMAP|V_30TRANS)
			v.drawNum(370, 140, player.mo.height, V_ORANGEMAP|V_30TRANS)
			v.drawNum(370, 150, player.fovadd, V_ORANGEMAP|V_30TRANS)
			v.drawNum(370, 160, player.fovchanger, V_ORANGEMAP|V_30TRANS)
			v.drawNum(370, 170, player.isrunningvar, V_ORANGEMAP|V_30TRANS)
			v.drawNum(370, 180, player.fovchanger2, V_ORANGEMAP|V_30TRANS)
			v.drawNum(370, 190, player.driftcooldown, V_ORANGEMAP|V_30TRANS)
			v.drawNum(370, 200, player.driftlagvar, V_ORANGEMAP|V_30TRANS)
			//v.drawNum(370, 180, player.cameramobj.momx, V_ORANGEMAP|V_30TRANS)
			//v.drawNum(370, 190, player.cameramobj.momy, V_ORANGEMAP|V_30TRANS)
			//v.drawNum(370, 200, player.cameramobj.momz, V_ORANGEMAP|V_30TRANS)
			v.drawString(210, 10, "H-Angle: ", V_ORANGEMAP|V_70TRANS)
			v.drawString(210, 20, "V-Angle: ", V_ORANGEMAP|V_70TRANS)
			v.drawString(210, 30, "Speed: ", V_ORANGEMAP|V_70TRANS)
			v.drawString(210, 40, "Friction: ", V_ORANGEMAP|V_70TRANS)
			v.drawString(210, 50, "Movefactor: ", V_ORANGEMAP|V_70TRANS)
			v.drawString(190, 60, "Angleholder: ", V_ORANGEMAP|V_70TRANS)
			v.drawString(190, 70, "Stick Angle: ", V_ORANGEMAP|V_70TRANS)
			v.drawString(210, 80, "Momentum Z: ", V_ORANGEMAP|V_70TRANS)
			v.drawString(210, 90, "Spring hit: ", V_ORANGEMAP|V_70TRANS)
			v.drawString(210, 100, "Sidemove: ", V_ORANGEMAP|V_70TRANS)
			v.drawString(210, 110, "Forwardmove: ", V_ORANGEMAP|V_70TRANS)
			v.drawString(210, 120, "Camera Z: ", V_ORANGEMAP|V_70TRANS)
			v.drawString(210, 130, "Camera Scale: ", V_ORANGEMAP|V_70TRANS)
			v.drawString(210, 140, "Height: ", V_ORANGEMAP|V_70TRANS)
			v.drawString(210, 150, "OGL FOV: ", V_ORANGEMAP|V_70TRANS)
			v.drawString(210, 160, "FOV changer: ", V_ORANGEMAP|V_70TRANS)
			v.drawString(210, 170, "Run var: ", V_ORANGEMAP|V_70TRANS)
			v.drawString(210, 180, "FOV changer2: ", V_ORANGEMAP|V_70TRANS)
			v.drawNum(100, 60, camera.momz, V_70TRANS)
			v.drawNum(100, 70, player.groundmomzh, V_70TRANS)
			v.drawNum(100, 80, camera.aiming, V_70TRANS)
			v.drawNum(100, 90, player.isonjumpv, V_70TRANS)
			v.drawNum(100, 100, player.jumpheldcv, V_70TRANS)
			v.drawNum(100, 120, player.driftstomper, V_70TRANS)
			v.drawNum(100, 130, player.groundfrictionchecker, V_70TRANS)
			v.drawNum(100, 140, player.campdistchecker, V_70TRANS)
		end
	end
end)